## terraphast 0.1.0+dfsg

=== CMakeLists.txt ===
project(terraphast C CXX)

cmake_minimum_required(VERSION 3.0.2)
cmake_policy(SET CMP0054 NEW)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

Option(DEV_ENVIRONMENT "Development environment (extended debugging)" OFF)

#####################################################################
# decide which components need to be built: by default, build everything,
# unless some components were explicitely disabled from the parent project
#####################################################################
Option(TERRAPHAST_USE_GMP "Use GMP" ON)
Option(TERRAPHAST_BUILD_CLIB "Build the C library" ON)
Option(TERRAPHAST_BUILD_APPS "Build the tools" ON)
Option(TERRAPHAST_BUILD_TESTS "Build the tests" ON)
Option(TERRAPHAST_ARCH_NATIVE "Use -march=native compiler flag" ON)

#####################################################################
# build library
#####################################################################
add_library(terraces
		lib/advanced.cpp
		lib/bigint.cpp
		lib/bipartitions.cpp
		lib/bipartitions.hpp
		lib/bitmatrix.cpp
		lib/bits.hpp
		lib/bitvector.hpp
		lib/clamped_uint.cpp
		lib/constraints.cpp
		lib/constraints_impl.hpp
		lib/errors.cpp
		lib/io_utils.hpp
		lib/multitree.cpp
		lib/multitree.hpp
		lib/multitree_impl.hpp
		lib/multitree_iterator.cpp
		lib/multitree_iterator.hpp
		lib/nodes.cpp
		lib/parser.cpp
		lib/ranked_bitvector.hpp
		lib/rooting.cpp
		lib/simple.cpp
		lib/small_bipartition.hpp
		lib/stack_allocator.hpp
		lib/subtree_extraction.cpp
		lib/subtree_extraction_impl.hpp
		lib/supertree_enumerator.hpp
		lib/supertree_helpers.cpp
		lib/supertree_helpers.hpp
		lib/supertree_variants.hpp
		lib/supertree_variants_debug.hpp
		lib/supertree_variants_multitree.hpp
		lib/trees.cpp
		lib/trees_impl.hpp
		lib/union_find.cpp
		lib/union_find.hpp
		lib/union_find_debug.hpp
		lib/utils.hpp
		lib/validation.cpp
		lib/validation.hpp
		# For QtCreator/CLion/... to show the files
		include/terraces/advanced.hpp
		include/terraces/bigint.hpp
		include/terraces/bitmatrix.hpp
		include/terraces/clamped_uint.hpp
		include/terraces/constraints.hpp
		include/terraces/definitions.hpp
		include/terraces/errors.hpp
		include/terraces/parser.hpp
		include/terraces/rooting.hpp
		include/terraces/simple.hpp
		include/terraces/subtree_extraction.hpp
		include/terraces/trees.hpp
)
target_include_directories(terraces
		PUBLIC include
		PRIVATE lib
)

if(TERRAPHAST_USE_GMP)
	find_package(GMP)
	if(GMP_FOUND)
		message(STATUS "GMP libraries found")
		target_link_libraries(terraces gmpxx gmp)
		target_compile_definitions(terraces PUBLIC USE_GMP)
	else()
		message(FATAL_ERROR "GMP libraries not found! Disable them using -DTERRAPHAST_USE_GMP=OFF")
	endif()
endif()

set(terraces_targets terraces)

if(TERRAPHAST_BUILD_CLIB)
	add_library(terraces_c
			c_lib/terraces.cpp
			c_include/terraces/terraces.h
	)
	target_include_directories(terraces_c PUBLIC c_include)
	target_link_libraries(terraces_c terraces)
	if (NOT TERRAPHAST_USE_GMP)
		message(FATAL_ERROR "The C library requires the GMP libraries to build! Enable them using -DTERRAPHAST_USE_GMP=ON")
	endif()

	set(terraces_targets ${terraces_targets} terraces_c)
endif()

#####################################################################
# internal compiler flags
#####################################################################
if(DEV_ENVIRONMENT AND CMAKE_BUILD_TYPE STREQUAL "Debug")
	target_compile_definitions(terraces PUBLIC _GLIBCXX_DEBUG) # PUBLIC to maintain ABI compatibility
	if(TERRAPHAST_BUILD_CLIB)
		target_compile_definitions(terraces_c PRIVATE _GLIBCXX_DEBUG) # PRIVATE since no stdlib objects are used
	endif()
endif()

#####################################################################
# build tools
#####################################################################
if(TERRAPHAST_BUILD_APPS)
	add_executable(app "app/app.cpp")
	add_executable(validated_run "tools/validated_run.cpp")
	add_executable(verbose_run "tools/verbose_run.cpp")
	add_executable(isomorphic "tools/isomorphic.cpp")
	add_executable(reroot "tools/reroot.cpp")
	add_executable(subtree "tools/subtree.cpp")
	add_executable(tree_gen "tools/tree_gen.cpp")
	add_executable(site_gen "tools/site_gen.cpp")
	add_executable(nwk_to_dot "tools/nwk_to_dot.cpp")
	target_link_libraries(validated_run terraces)
	target_link_libraries(verbose_run terraces)
	target_link_libraries(isomorphic terraces)
	target_link_libraries(reroot terraces)
	target_link_libraries(subtree terraces)
	target_link_libraries(tree_gen terraces)
	target_link_libraries(site_gen terraces)
	target_link_libraries(nwk_to_dot terraces)
	target_link_libraries(app terraces)

	set(terraces_targets ${terraces_targets} app validated_run verbose_run isomorphic reroot subtree tree_gen site_gen nwk_to_dot)
endif()

#####################################################################
# build tests
#####################################################################
if(TERRAPHAST_BUILD_TESTS)
	add_library(Catch INTERFACE)
	target_include_directories(Catch INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/catch)

	add_executable(unittests
		test/main.cc
		test/advanced.cpp
		test/bipartitions.cpp
		test/bitmatrix.cpp
		test/bits.cpp
		test/bitvector.cpp
		test/clamped_uint.cpp
		test/constraints.cpp
		test/compile_test.cpp
		test/fast_set.cpp
		test/integration.cpp
		test/multitree_iterator.cpp
		test/parser.cpp
		test/rooting.cpp
		test/small_bipartition.cpp
		test/stack_allocator.cpp
		test/subtree_extraction.cpp
		test/supertree.cpp
		test/trees.cpp
		test/union_find.cpp
		test/util.cpp
		test/validation.cpp
		test/simple.cpp
		test/limited.cpp
	)
	target_link_libraries(unittests terraces Catch)
	if(TERRAPHAST_BUILD_CLIB)
		target_sources(unittests PRIVATE
			test/c_api.cpp
		)
		target_link_libraries(unittests terraces_c)
	endif()
	add_test(NAME unittests COMMAND unittests)
	enable_testing()

	set(terraces_targets ${terraces_targets} unittests)
endif()

set_target_properties(${terraces_targets} PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)

#####################################################################
# set platform-specific options, include platform-specific files
#####################################################################
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
	set(TERRAPHAST_PLATFORM_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/lib/cl")
	set(TERRAPHAST_COMPILE_FLAGS -Oi -W4)

	# Most of our files only compile with disabled language extensions for VC++
	# Unfortunately, Catch uses some windows-specific features, so we have to
	# enable these extensions for the Catch main method (more specific: not disable them)
	file(GLOB ALL_SOURCES lib/*.cpp c_lib/*.cpp test/*.cpp tools/*.cpp app/*.cpp)
	set_source_files_properties(${ALL_SOURCES} PROPERTIES COMPILE_FLAGS "-Za")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
	set(TERRAPHAST_PLATFORM_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/lib/intel")
	set(TERRAPHAST_COMPILE_FLAGS -Wall -Wextra -Wconversion -Wsign-conversion -Werror)
	if(TERRAPHAST_ARCH_NATIVE)
		set(TERRAPHAST_COMPILE_FLAGS -march=native ${TERRAPHAST_COMPILE_FLAGS})
	endif()
else()
	set(TERRAPHAST_PLATFORM_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/lib/gcc_clang")
	set(TERRAPHAST_COMPILE_FLAGS -Wall -Wextra -Wpedantic -Wconversion -Wsign-conversion -Werror)
	if(TERRAPHAST_ARCH_NATIVE)
		set(TERRAPHAST_COMPILE_FLAGS -march=native ${TERRAPHAST_COMPILE_FLAGS})
	endif()
endif()

target_include_directories(terraces PUBLIC "${TERRAPHAST_PLATFORM_INCLUDE}")
if(TERRAPHAST_BUILD_TESTS)
	target_include_directories(unittests PRIVATE "${TERRAPHAST_PLATFORM_INCLUDE}")
endif()
target_compile_options(terraces PRIVATE "${TERRAPHAST_COMPILE_FLAGS}")
if(TERRAPHAST_BUILD_CLIB)
	target_compile_options(terraces_c PRIVATE "${TERRAPHAST_COMPILE_FLAGS}")
endif()

#####################################################################
# setup clang-tidy
#####################################################################
find_program(CLANG_TIDY_PATH NAMES "clang-tidy")
if(NOT CLANG_TIDY_PATH)
	message(STATUS "clang-tidy not found.")
else()
	message(STATUS "clang-tidy found: ${CLANG_TIDY_PATH}")
	set(CLANG_TIDY_COMMANDLINE "${CLANG_TIDY_PATH}" "-checks=llvm-namespace-comment -fix")
endif()

#set_target_properties(terraces terraces_c app validated_run verbose_run isomorphic reroot subtree tree_gen site_gen nwk_to_dot unittests PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_COMMANDLINE}")

## terraphast 0.0+git20200413.8af2e4c

=== debian/changelog ===
terraphast (0.0+git20200413.8af2e4c-2) unstable; urgency=medium

  * Packaging update

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 13:57:33 +0100

terraphast (0.0+git20200413.8af2e4c-1) unstable; urgency=medium

  * Initial release (Closes: #1004148)

 -- Andreas Tille <tille@debian.org>  Fri, 21 Jan 2022 19:18:40 +0100

=== debian/control ===
Source: terraphast
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               dh-exec,
               libgmp3-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/terraphast
Vcs-Git: https://salsa.debian.org/med-team/terraphast.git
Homepage: https://github.com/amkozlov/terraphast-one
Rules-Requires-Root: no

Package: terraphast
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libterraces0 (= ${binary:Version})
Description: enumerate terraces in phylogenetic tree space
 Terraphast takes a .nkw file in Newick format and a genes/sites file,
 which denotes whether (1) or not (0) gene i is present in species j.
 .
 Program output states some imput data properties, the species whose leaf
 edge is used as a new tree root, and the resulting supertree in
 compressed newick format.

Package: libterraces0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: enumerate terraces in phylogenetic tree space (shared lib)
 Terraphast takes a .nkw file in Newick format and a genes/sites file,
 which denotes whether (1) or not (0) gene i is present in species j.
 .
 Program output states some imput data properties, the species whose leaf
 edge is used as a new tree root, and the resulting supertree in
 compressed newick format.
 .
 This package contains the shared library.

Package: libterraces-dev
Architecture: any
Section: libdevel
Depends: libterraces0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: enumerate terraces in phylogenetic tree space (development lib)
 Terraphast takes a .nkw file in Newick format and a genes/sites file,
 which denotes whether (1) or not (0) gene i is present in species j.
 .
 Program output states some imput data properties, the species whose leaf
 edge is used as a new tree root, and the resulting supertree in
 compressed newick format.
 .
 This package contains a library to use the terraphast algorithm in own
 projects.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

#Set VERSION and SOVERSION
VERSION=0.0
SOVERSION=0

BUILDDIR:=obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DVERSION="$(VERSION)" \
		-DSOVERSION="$(SOVERSION)"

override_dh_install:
	mkdir -p debian/$(DEB_SOURCE)/usr/bin
	mv $(BUILDDIR)/app debian/$(DEB_SOURCE)/usr/bin/$(DEB_SOURCE)
	mv $(BUILDDIR)/libterraces_static.a $(BUILDDIR)/libterraces.a
	mv $(BUILDDIR)/libterraces_c_static.a $(BUILDDIR)/libterraces_c.a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libgmpxx4-dev/libgmpxx4ldbl/ \
		    --movedev include usr \
		    $(BUILDDIR)/libterraces.so
	dh_install

=== debian/watch ===
version=4

opts="mode=git,pretty=0.0+git%cd.%h" \
    https://github.com/amkozlov/terraphast-one.git HEAD

## terraphast 0.0+git20200413.8af2e4c+dfsg

=== debian/changelog ===
terraphast (0.0+git20200413.8af2e4c+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Komolehin Israel Timilehin ]
  * Added autopkgtest

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)
  * Make sure include dir in source tree will not be deleted
    Closes: #1049550

 -- Komolehin Israel Timilehin <komolehinisrael@gmail.com>  Tue, 30 Jan 2024 09:14:48 +0100

terraphast (0.0+git20200413.8af2e4c+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Disallow lto (Closes: #1015687)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 30 Dec 2022 11:38:43 +0530

terraphast (0.0+git20200413.8af2e4c+dfsg-1) unstable; urgency=medium

  * Remove code copy of catch
    Closes: #1013269

 -- Andreas Tille <tille@debian.org>  Mon, 25 Jul 2022 15:18:53 +0200

terraphast (0.0+git20200413.8af2e4c-3) unstable; urgency=medium

  * Team upload.
  * d/rules: avoid using march=native
  * Bump Standards-Version to 4.6.1 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Wed, 06 Jul 2022 12:13:17 +0530

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,9 @@
                cmake,
                d-shlibs,
                dh-exec,
+               catch,
                libgmp3-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/terraphast
 Vcs-Git: https://salsa.debian.org/med-team/terraphast.git
 Homepage: https://github.com/amkozlov/terraphast-one

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto

#Set VERSION and SOVERSION
VERSION=0.0
SOVERSION=0

BUILDDIR:=obj-$(DEB_HOST_GNU_TYPE)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DVERSION="$(VERSION)" \
		-DSOVERSION="$(SOVERSION)" \
		-DTERRAPHAST_ARCH_NATIVE=OFF

override_dh_install:
	mkdir -p debian/$(DEB_SOURCE)/usr/bin
	mv $(BUILDDIR)/app debian/$(DEB_SOURCE)/usr/bin/$(DEB_SOURCE)
	mv $(BUILDDIR)/libterraces_static.a $(BUILDDIR)/libterraces.a
	mv $(BUILDDIR)/libterraces_c_static.a $(BUILDDIR)/libterraces_c.a
	cp -a include $(BUILDDIR)
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libgmpxx4-dev/libgmpxx4ldbl/ \
		    --movedev $(BUILDDIR)/include usr \
		    $(BUILDDIR)/libterraces.so
	dh_install

=== debian/tests/control ===
Tests: run-unit-test
Depends: wget, terraphast
Restrictions: needs-internet, allow-stderr

=== debian/watch ===
version=4

opts="mode=git,pretty=0.0+git%cd.%h,repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
    https://github.com/amkozlov/terraphast-one.git HEAD

## terraphast 0.1.0%2Bdfsg

=== debian/watch ===
Version: 5

Template: Github
Owner: amkozlov
Project: terraphast-one
Repack-Suffix: +dfsg
Dversion-Mangle: auto

## terraphast 0.1.0+dfsg

=== debian/changelog ===
terraphast (0.1.0+dfsg-1) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1113569
  * d/watch: version=5 (now based on release tag)
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Provide test data as examples and do not require autopkgtest
    accessing internet

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 14:16:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: terraphast
+Standards-Version: 4.7.2
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders:
+ Andreas Tille <tille@debian.org>,
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               cmake,
-               d-shlibs,
-               dh-exec,
-               catch,
-               libgmp3-dev
-Standards-Version: 4.6.2
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ d-shlibs,
+ dh-exec,
+ catch,
+ libgmp3-dev,
 Vcs-Browser: https://salsa.debian.org/med-team/terraphast
 Vcs-Git: https://salsa.debian.org/med-team/terraphast.git
 Homepage: https://github.com/amkozlov/terraphast-one
@@ -18,9 +20,10 @@
 Package: terraphast
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         libterraces0 (= ${binary:Version})
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ libterraces0 (= ${binary:Version}),
 Description: enumerate terraces in phylogenetic tree space
  Terraphast takes a .nkw file in Newick format and a genes/sites file,
  which denotes whether (1) or not (0) gene i is present in species j.
@@ -32,8 +35,9 @@
 Package: libterraces0
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
 Description: enumerate terraces in phylogenetic tree space (shared lib)
  Terraphast takes a .nkw file in Newick format and a genes/sites file,
  which denotes whether (1) or not (0) gene i is present in species j.
@@ -47,9 +51,10 @@
 Package: libterraces-dev
 Architecture: any
 Section: libdevel
-Depends: libterraces0 (= ${binary:Version}),
-         ${shlibs:Depends},
-         ${misc:Depends}
+Depends:
+ libterraces0 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends},
 Description: enumerate terraces in phylogenetic tree space (development lib)
  Terraphast takes a .nkw file in Newick format and a genes/sites file,
  which denotes whether (1) or not (0) gene i is present in species j.

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,8 @@
 	dh_auto_configure -- \
 		-DVERSION="$(VERSION)" \
 		-DSOVERSION="$(SOVERSION)" \
-		-DTERRAPHAST_ARCH_NATIVE=OFF
+		-DTERRAPHAST_ARCH_NATIVE=OFF \
+		-DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_install:
 	mkdir -p debian/$(DEB_SOURCE)/usr/bin
